# A single sprite

import pyglet

BOUNDS = (50, 50, 500, 400)

class MySprite(pyglet.sprite.Sprite):

    def __init__(self, img, x, y, x_velocity, y_velocity):
        super(MySprite, self).__init__(img, x, y)
        self.x_velocity = x_velocity
        self.y_velocity = y_velocity
        pyglet.clock.schedule_interval(self.update, 0.016)

    def _check_x_bounds(self):
       if self.x < BOUNDS[0] or self.x > BOUNDS[2]:
          return False
       return True

    def _check_y_bounds(self):
       if self.y < BOUNDS[1] or self.y > BOUNDS[3]:
          return False
       return True

    def update(self, dt):
       self.x += self.x_velocity
       self.y += self.y_velocity
       if not self._check_x_bounds():
          self.x_velocity = -self.x_velocity
       if not self._check_y_bounds():
          self.y_velocity = -self.y_velocity

class MyWindow(pyglet.window.Window):

    def __init__(self):
        super(MyWindow, self).__init__()
        self._image = pyglet.resource.image('blueball.png')
        self._sprite = MySprite(self._image, 200, 200, 2, 2)

    def on_draw(self):
        self.clear()
        self._sprite.draw()

if __name__ == "__main__":
    win = MyWindow()
    pyglet.app.run()
